---- CombustionTracker -- made by Tracerus on Wrathbringer (EU) ----------

CombustionTracker_Version = "1.11";
CombustionTracker_maxCrits = 3;
CombustionTracker_CritsLeft = CombustionTracker_maxCrits;
CombustionTracker_CombustionActive = false;
CombustionTracker_VariablesLoaded = false;
CombustionTracker_TextureName = "(.+)SealOfFire";

function CombustionTracker_OnLoad()
	--disable this mod if we are not a mage (not really disable but just do nothing)
	if (not (COMBUSTIONTRACKER_MAGE == UnitClass("player"))) then
		DEFAULT_CHAT_FRAME:AddMessage(COMBUSTIONTRACKER_DISABLED);
		return;
	end
	
	--welcome message
	DEFAULT_CHAT_FRAME:AddMessage("CombustionTracker v"..CombustionTracker_Version.." "..COMBUSTIONTRACKER_LOADED);
	
	--register all events we need
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("VARIABLES_LOADED");	
end

function CombustionTracker_OnEvent()
	if( event=="VARIABLES_LOADED") then
		CombustionTracker_VariablesLoaded = true;
		
		--if we logged out with active combustion we still have the buff
		if( CombustionTracker_CombustionActive ) then
			--place text under combustion buff icon and show it
			CombustionTracker_UpdateText();
			CombustionTracker_MainFrame_CRIT_NUMBER:Show();
		end
	end
	
	--do nothin if variables have not been loaded yet
	if( CombustionTracker_VariablesLoaded==false ) then
		return;
	end
	
	--if we got a buff and system message is equal to combustion gain message ...
	if( event=="CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" and arg1==COMBUSTIONTRACKER_AURAGAIN ) then
		CombustionTracker_CritsLeft = CombustionTracker_maxCrits;
		CombustionTracker_CombustionActive = true;
		CombustionTracker_MainFrame_CRIT_NUMBER:Show()
		--DEFAULT_CHAT_FRAME:AddMessage("Combustion aktiviert");
	--everything else only matters if combustion is already active
	elseif( CombustionTracker_CombustionActive ) then
		--if a buff is gone and system message is equal to combustion fade message        OR if we died
		if( (event=="CHAT_MSG_SPELL_AURA_GONE_SELF" and arg1==COMBUSTIONTRACKER_AURALOSE) or event=="PLAYER_DEAD" ) then
			CombustionTracker_MainFrame_CRIT_NUMBER:Hide();
			--CombustionTracker_CritsLeft = CombustionTracker_maxCrits;
			CombustionTracker_CombustionActive = false;
			--DEFAULT_CHAT_FRAME:AddMessage("Combustion beendet");
		--...or did we just do damage...
		elseif( event=="CHAT_MSG_SPELL_SELF_DAMAGE" ) then
			--if we had a critical hit                       and it is a firespell
			if( string.find(arg1, COMBUSTIONTRACKER_CRITHIT) and IsFirespellMessage(arg1) ) then
				--decrease number of crits left
				CombustionTracker_CritsLeft = CombustionTracker_CritsLeft-1;

				--sometimes it takes a while until buff fades, so hide the UI text if there are 0 crits left
				if( CombustionTracker_CritsLeft<=0 ) then
					CombustionTracker_MainFrame_CRIT_NUMBER:Hide();
					CombustionTracker_CombustionActive = false;
				--else update text
				else
					CombustionTracker_MainFrame_CRIT_NUMBER:SetText( CombustionTracker_CritsLeft );
				end
			end
		--if any buff changed we maybe have to reposition the UI text ...
		elseif( event=="PLAYER_AURAS_CHANGED" ) then
			--...so we update it
			CombustionTracker_UpdateText();
		end
	end
end

--updates the text position (and content)
function CombustionTracker_UpdateText()
	--go through all the buffs 
	for i = 0, 23, 1 do
		local buffIndex, untilCancelled = GetPlayerBuff(i, "HELPFUL");
		--test if we found a buff and get its texturename
		if ( buffIndex >= 0 ) then
			local buffTexture = GetPlayerBuffTexture(buffIndex);	
			
			--test if it is combustion texture
			if (string.find(buffTexture, CombustionTracker_TextureName)) then
			
				--generate tooltip for this buff and extract buffname
				CombustionTracker_Tooltip:SetOwner(getglobal("BuffButton"..i), "ANCHOR_BOTTOMLEFT");
				CombustionTracker_Tooltip:SetPlayerBuff(buffIndex);
				local buffName = tostring(CombustionTracker_TooltipTextLeft1:GetText());
				CombustionTracker_Tooltip:Hide();
				
				--check if this is really combustion buff
				if ( COMBUSTIONTRACKER_COMBUSTION == buffName ) then
					--place UI text under combustion buff and update text
					CombustionTracker_MainFrame_CRIT_NUMBER:SetPoint("TOP", "BuffButton"..i, "BOTTOM", -2, -2);
					CombustionTracker_MainFrame_CRIT_NUMBER:SetText(CombustionTracker_CritsLeft);

					--we found combustion buff and can stop going through bufflist
					return;
				end
			end
		end
	end
	--no combustion buff found -> hide number
	CombustionTracker_MainFrame_CRIT_NUMBER:Hide();
end

--checks if a given message contains a fire spellname
function IsFirespellMessage(msg)
	local i=1;
	--go through the list of firespells and return true if one is found in the message
	while( COMBUSTIONTRACKER_FIRESPELLS[i] ) do
		if( string.find(msg, COMBUSTIONTRACKER_FIRESPELLS[i]) ) then
			return true;
		end
		i = i+1;
	end
	
	--else return false
	return false;
end